unit dllutil;



interface

uses objects,global,types;

function Int2Str(long:longint):String;

function AddSpaces(st:string;n:byte;ch:char;mode:boolean):string;

function Pnt2Str(const P:PString):string;

Procedure NewPAddr2NewAddr(const Addr:NewPAddr;var AAddr:NewAddress);

function  Str2NewAddr(S:String;var Addr:NewAddress):boolean;

Function  NewAddr2Str(const Addr:NewAddress):string;


implementation

function Int2Str(long:longint):String;
var s:string;
begin
 Str(long,s);
 Int2Str:=s
end;

function AddSpaces(st:string;n:byte;ch:char;mode:boolean):string;
  Var
    i: Word;stt:string;oldlen:byte;
  Begin
  fillchar(stt,sizeof(stt),#0);
  if not mode then begin
  oldlen:=length(st)+1;
  SetLength(st,n);stt:=st;
  For i := oldlen to Length(St) Do Stt[i]:=ch;
  end else begin
  if length(st)>n then
  stt:=copy(st,length(st)-n+1,length(st)) else
  begin
  SetLength(stt,n);fillchar(stt[1],sizeof(stt)-1,ch);
  for i:=length(stt) downto (length(stt)-length(st))+1 do stt[i]:=st[i-(length(stt)-length(st))];
  end;
  end;
  addspaces:=stt
  End;


function Pnt2Str(const P:PString):string;
begin
 pnt2str:='';
 if p=nil then exit;
 pnt2str:=p^;
end;

Procedure NewPAddr2NewAddr(const Addr:NewPAddr;var AAddr:NewAddress);
begin
Fillchar(AAddr,Sizeof(AAddr),#0);
if Addr=nil then exit;
AAddr.Zone:=Addr^.Zone;
AAddr.Net:=Addr^.Net;
AAddr.Node:=Addr^.Node;
AAddr.Point:=Addr^.Point;
if Addr^.Domain<>nil then AAddr.Domain:=pnt2str(Addr^.domain);
AAddr.active:=Addr^.Active;
end;

function  Str2NewAddr(S:String;var Addr:NewAddress):boolean;
var
   bb,
   b,
   b1,
   b2:integer;
   ar:string;
   ra:longint;
   Zone,Net,Node,Point:Word;
   Dom:String;
 begin
 Str2NewAddr:=false;
 Fillchar(Addr,Sizeof(Addr),#0);
 if s='' then exit;
 if s=';' then exit;
 if pos('@',s)<>0 then
 begin
  ar:=copy(s,pos('@',s)+1,(length(s)-pos('@',s)+1));
  if pos('.',ar)<>0 then ar:=copy(ar,1,pos('.',ar)-1);
  if length(ar)>8 then setlength(ar,8);Dom:=ar;
  if pos('.',dom)<>0 then dom:=copy(dom,1,pos('.',dom))
 end
 else dom:='';
 b:=pos(':',s);
 if (b<=0) or (b>6) then
 begin
  exit
 end;
 ar:='';
 for bb:=1 to b-1 do
 if (s[bb] in ['0'..'9']) then ar:=ar+s[bb];
 val(ar,ra,error);
 if error<>0 then
 begin
  exit
 end;
 if ra=0 then
 begin
  exit
 end;
 Zone:=ra;
 b1:=pos('/',s);
 ar:='';
 if (b1<=0) or (b1>12) or (b>=b1) then
 begin
  exit
 end;
 for bb:=b+1 to b1-1 do
 if (s[bb] in ['0'..'9']) then ar:=ar+s[bb];
 val(ar,ra,error);
 if error<>0 then
 begin
  exit
 end;
 net:=ra;
 b2:=pos('.',s);
 if b2<=0 then b2:=length(s)+1;
 if (b1>=b2) then
 begin
  exit
 end;
 ar:='';
 for bb:=b1+1 to b2-1 do
 if (s[bb] in ['0'..'9']) then ar:=ar+s[bb];
 val(ar,ra,error);
 if error<>0 then
 begin
  exit
 end;
 Node:=ra;
 ar:='';
 if (b2<>length(s)) or (b2<=18) then
 begin
  for bb:=b2+1 to length(s) do
  if (s[bb] in ['0'..'9']) then ar:=ar+s[bb];
 end;
 if ar='' then ar:='0';
 val(ar,ra,error);
 if error<>0 then ra:=0;
 Point:=ra;
 addr.Zone  :=zone;
 addr.Net   :=net;
 addr.Node  :=node;
 addr.Point :=point;
 addr.Domain:=dom;
 addr.Active:=true;
 Str2NewAddr:=true;
end;


Function  NewAddr2Str(const Addr:NewAddress):string;
var z,ne,no,po:string;
begin
Newaddr2str:='';
if addr.zone=0 then exit;

str(addr.zone,z);str(addr.net,ne);
str(addr.node,no);str(addr.point,po);
if Str2NewAddr(z+':'+ne+'/'+no+'.'+po,temp) then begin NewAddr2Str:=z+':'+ne+'/'+no+'.'+po end;
end;

end.
