(*   vvvv - name changed by sv *)
{$I TICGUARD.INC}
(*_   묨 ।ﬨ  _*)

unit tg_glob;
interface
const
 {// Internal errors}
  er_AllOk            = 0;
  er_MemoryError      = 222;
  er_TicError         = 223;
  er_OTHERERROR       = 255;
 {// DOS errors}
  er_FileNotFound     = 2;
  er_PathNotFound     = 3;
  er_TooManyOpenFiles = 4;
  er_FileAccessDenied = 5;
  er_InvDriveNum      = 15;
  er_CantRenAcrDrv    = 17;
  {// I/O errors}
  er_DiskReadError    = 100;
  er_DiskWriteError   = 101;
  er_FileNotOpen      = 102;
  {// Critical Errors}
  er_DiskWriteProt    = 150;
  er_UnknownUnit      = 151;
  er_DriveNotReady    = 152;
  er_UnknownCommand   = 153;
  er_CrcErrorInData   = 154;
  er_BadDrvReq        = 155;
  er_DiskSeekError    = 156;
  er_UnknownMediaType = 157;
  er_SectorNotFound   = 158;
  er_DeviceWriteFault = 160;
  er_DeviceReadFault  = 161;
  er_HardwareFailure  = 162;

TYPE
  Ttic = record
    FName   : string[12];
    Tic     : string[8];
    CRC32   : longint;
    NextTic : pointer;
  end;

implementation
begin
end.
