{$F+}
unit global;

interface

uses objects,dos,types{$IFNDEF MSDOS},windows{$ENDIF};

type

PStrings = ^TStrings;
TStrings = object(TCollection)
 procedure FreeItem(Item: Pointer); virtual;
end;


feclink = record
Address:NewAddress;
Status:Char;
end;

Mailer          = (Attach,Portal,Xenia,FileBox,User);

{$IFDEF MSDOS}
nstring         =string[12];
{$ELSE}
nstring         =string;
{$ENDIF}

felistffx       = record {felist.ffx}
area                      :string[36];
description               :string[80];
end;

announceffx     = record {announce.ffx}
path                     :string;
area                     :string[36];
from                     :addrtype;
groups                   :string[40];
password                 :string[8];
destination              :addrtype;
end;

newareagroupffx = record {newareag.ffx}
address                  :addrtype;
group                    :char;
path                     :string;
Flags                    :string;
links                    :array [1..255] of addrtype;   {links.ffx}
end;


linksffx        = record {links.ffx}
address                 :addrtype;
sysopname               :string[36];
password                :string[8];
flags                   :string;
groups                  :string[26];
route                   :char;
end;

fileechosffx    = record
area                    :string[36];
path                    :string;
flags                   :string;
description             :string[60];
group                   :string[26];
links                   :array [1..512] of feclink;
end;

configffx       = record
fastfixid               :word;
address                 :array [1..40] of addrtype;
getfileiddiz            :array [1..20] of nstring;
putfilesbbs             :array [1..20] of nstring;
inbound                 :string;
outbound                :string;
netmail_in              :string;
netmail_out             :string;
baddirectory            :string;
dupedirectory           :string;
tempdirectory           :string;
logdirectory            :string;
bsydirectory            :string;
fileechodirectory       :string;
passtroughdirectory     :string;
utc                     :integer;
mainzone                :word;
backup                  :boolean;
logchars                :string[6];
mailermode              :mailer;
ignores                 :byte;
addfiles                :array [1..10] of string[80];
addcomment              :nstring;
masksupport             :boolean;
longnames               :boolean;
dupelimit               :longint;
dupecheck               :byte;
sorigin                 :string[80];
cutmessages             :word;
crcid                   :string[8];
end;

var

                Parameter              :Integer;
                NextParam              :Integer;
                CFG,CFG2,CFG3          :Text;

                Posit                  :Word;
                Flog                   :Text;
                Error                  :Integer;
                RS,RS1,RS2             :Searchrec;

                lastmsgid:string;
                num:longint;

                tfl                    :word; {- p 䠩}

                MailerMode       :Mailer;
                UpdateConfig     :Boolean;

const
  fRead     = 1;
  fAppend   = 2;
  frewrite  = 3;

const

     Ok                         = 00000;
     LowSendSecurity            = 00001;
     LowReceiveSecurity         = 00002;
     CreateFechoError           = 00004;
     OriginIsUnknown            = 00008;
     FromIsUnknown              = 00016;
     FileIsMissed               = 00032;
     SizeError                  = 00064;
     DestinationIsNotForUs      = 00128;
     DupeLink                   = 00256;
     ReplaceError               = 00512;
     CRCError                   = 01024;
     BadPassword                = 02048;
     UnknownFecho               = 04096;
     NoLink                     = 08192;
     UnknownLink                = 16384;

     UnknownArchive             = 32768;
     FileReadError              = 65535;

{$IFDEF WIN32}
const version='FastFIX/W32 v1.00 alpha 4';

const sversion='w32.1004a';

const MaxMsgSize=65535;

const rights='Copyright (C) 1997-99 by Michail A.Baikov  (2:5020/1305)';

type
RTic          = record
{H 䠩}
                Area             :PString;
{ᠭ 䠩}
                AreaDesc         :PString;
{p ⥬,  p 䠩  y饭  䠩y}
                Origin           :NewPAddr;
{p ⥬,  p  ⥬ y稫 䠩}
                From             :NewPAddr;
{ 䠩}
                File_            :PString;
{ 䠩}
                Size             :Longint;
{p⪮ ᠭ}
                Desc             :PString;
{ ᠭ}
                LDesc            :PCollection;
{p     p祭 TIC-䠩}
                Destination      :NewPAddr;
{Path}
                Path             :PCollection;
{Seen-by}
                Seenby           :PCollection;
{᪠  堭 REPLACE}
                Replaces         :PString;
{CRC-32 䠩}
                Crc              :String;
{p}
                Password         :PString;
{ ᮧ tic-䠩}
                Created          :PString;
end;

RTossUpdateScreen = record
        NameTic         :PString;
        TotalSize       :Longint;
        CurrentSize     :Longint;
        CurrentTic      :Longint;
        TotalTics       :Longint;
        TotalFiles      :Longint;
        SpeedTics       :Longint;
        SpeedFiles      :Longint;
        TotalTime       :Longint;
        Tic             :RTic;
        SendMessage     :PString;
        Reserved        :Longint;

        NormalFiles     :Longint;
        DuplicateFiles  :Longint;
        TransitFiles    :Longint;
        PasstroughFiles :Longint;
        BadFiles        :Longint;
        CarbonNotify    :Longint;
        TotalExport     :Longint;

        H,M,S,H2,M2,S2  :Byte;  //Time
        EH,EM,ES        :Byte;  //External Time
        Update          :Boolean;
end;

var Handle_:array [0..255] of THandle;

type _beforetoss=procedure (inbound,baddir:string);
     _beforeannounce=procedure (announdir,sys:string);
     _beforework=procedure (path_0:string;sys:string;param:string);
     _usagehelp=procedure (path:PathStr;param:string);
     _afterwork=procedure (sys:string;param:string);
     _inittoss=procedure;
     _updatetoss=procedure (const UpdateRec:RTossUpdateScreen);
     _id=function:string;
     _x=function (filename:string;key:string):string;
     _init=procedure (P:Pointer);

var beforetoss:_beforetoss;
    beforeannounce:_beforeannounce;
    beforework:_beforework;
    usagehelp:_usagehelp;
    afterwork:_afterwork;
    inittoss:_inittoss;
    updatetoss:_updatetoss;
    id:_id;
    x,x1:_x;
    init:_init;

{$ENDIF}

{$IFDEF DPMI32}
const version='FastFIX/DOS v1.00 alpha 4';

const sversion='d32.1004a';

const MaxMsgSize=65535;

const rights='Copyright (C) 1997-99 by Michail A.Baikov  (2:5020/1305)';

type
RTic          = record
{H 䠩}
                Area             :PString;
{ᠭ 䠩}
                AreaDesc         :PString;
{p ⥬,  p 䠩  y饭  䠩y}
                Origin           :NewPAddr;
{p ⥬,  p  ⥬ y稫 䠩}
                From             :NewPAddr;
{ 䠩}
                File_            :PString;
{ 䠩}
                Size             :Longint;
{p⪮ ᠭ}
                Desc             :PString;
{ ᠭ}
                LDesc            :PCollection;
{p     p祭 TIC-䠩}
                Destination      :NewPAddr;
{Path}
                Path             :PCollection;
{Seen-by}
                Seenby           :PCollection;
{᪠  堭 REPLACE}
                Replaces         :PString;
{CRC-32 䠩}
                Crc              :String;
{p}
                Password         :PString;
{ ᮧ tic-䠩}
                Created          :PString;
end;

RTossUpdateScreen = record
        NameTic         :PString;
        TotalSize       :Longint;
        CurrentSize     :Longint;
        CurrentTic      :Longint;
        TotalTics       :Longint;
        TotalFiles      :Longint;
        SpeedTics       :Longint;
        SpeedFiles      :Longint;
        TotalTime       :Longint;
        Tic             :RTic;
        SendMessage     :PString;
        Reserved        :Longint;

        NormalFiles     :Longint;
        DuplicateFiles  :Longint;
        TransitFiles    :Longint;
        PasstroughFiles :Longint;
        BadFiles        :Longint;
        CarbonNotify    :Longint;
        TotalExport     :Longint;

        H,M,S,H2,M2,S2  :Byte;  //Time
        EH,EM,ES        :Byte;  //External Time
        Update          :Boolean;
end;

var Handle_:array [0..255] of THandle;

type _beforetoss=procedure (inbound,baddir:string);
     _beforeannounce=procedure (announdir,sys:string);
     _beforework=procedure (path_0:string;sys:string;param:string);
     _usagehelp=procedure (path:PathStr;param:string);
     _afterwork=procedure (sys:string;param:string);
     _inittoss=procedure;
     _updatetoss=procedure (const UpdateRec:RTossUpdateScreen);
     _id=function:string;
     _x=function (filename:string;key:string):string;
     _init=procedure (P:Pointer);

var beforetoss:_beforetoss;
    beforeannounce:_beforeannounce;
    beforework:_beforework;
    usagehelp:_usagehelp;
    afterwork:_afterwork;
    inittoss:_inittoss;
    updatetoss:_updatetoss;
    id:_id;
    x,x1:_x;
    init:_init;

{$ENDIF}


{$IFDEF MSDOS}

const version='FastFIX v1.00 alpha 4';

const sversion='d16.100a4';

const MaxMsgSize=32768;

const rights='Copyright (C) 1997-99 by Michail A.Baikov  (2:5020/1305)';
{$ENDIF}

{$IFDEF OS2}

const version='FastFIX/2 v1.00 alpha 4';

const sversion='os2.100a4';

const MaxMsgSize=65535;

const rights='Copyright (C) 1997-99 by Michail A.Baikov  (2:5020/1305)';

type
RTic          = record
{H 䠩}
                Area             :PString;
{ᠭ 䠩}
                AreaDesc         :PString;
{p ⥬,  p 䠩  y饭  䠩y}
                Origin           :NewPAddr;
{p ⥬,  p  ⥬ y稫 䠩}
                From             :NewPAddr;
{ 䠩}
                File_            :PString;
{ 䠩}
                Size             :Longint;
{p⪮ ᠭ}
                Desc             :PString;
{ ᠭ}
                LDesc            :PCollection;
{p     p祭 TIC-䠩}
                Destination      :NewPAddr;
{Path}
                Path             :PCollection;
{Seen-by}
                Seenby           :PCollection;
{᪠  堭 REPLACE}
                Replaces         :PString;
{CRC-32 䠩}
                Crc              :String;
{p}
                Password         :PString;
{ ᮧ tic-䠩}
                Created          :PString;
end;

RTossUpdateScreen = record
        NameTic         :PString;
        TotalSize       :Longint;
        CurrentSize     :Longint;
        CurrentTic      :Longint;
        TotalTics       :Longint;
        TotalFiles      :Longint;
        SpeedTics       :Longint;
        SpeedFiles      :Longint;
        TotalTime       :Longint;
        Tic             :RTic;
        SendMessage     :PString;
        Reserved        :Longint;

        NormalFiles     :Longint;
        DuplicateFiles  :Longint;
        TransitFiles    :Longint;
        PasstroughFiles :Longint;
        BadFiles        :Longint;
        CarbonNotify    :Longint;
        TotalExport     :Longint;

        H,M,S,H2,M2,S2  :Byte;  //Time
        EH,EM,ES        :Byte;  //External Time
        Update          :Boolean;
end;


var Handle_:array [0..255] of THandle;

type _beforetoss=procedure (inbound,baddir:string);
     _beforeannounce=procedure (announdir,sys:string);
     _beforework=procedure (path_0:string;sys:string;param:string);
     _usagehelp=procedure (path:PathStr;param:string);
     _afterwork=procedure (sys:string;param:string);
     _inittoss=procedure;
     _updatetoss=procedure (const UpdateRec:RTossUpdateScreen);
     _id=function:string;
     _x=function (filename:string;key:string):string;
     _init=procedure (P:Pointer);

var beforetoss:_beforetoss;
    beforeannounce:_beforeannounce;
    beforework:_beforework;
    usagehelp:_usagehelp;
    afterwork:_afterwork;
    inittoss:_inittoss;
    updatetoss:_updatetoss;
    id:_id;
    x,x1:_x;
    init:_init;

{$ENDIF}

implementation

procedure TStrings.FreeItem(Item: Pointer);
 begin
  DisposeStr(Item);
 end;


begin
lastmsgid:='';
end.


