(*   vvvv - name changed by sv *)
{$I TICGUARD.INC}
unit tg_error;
interface
  function ErrorMsg(ErrorCode:byte):string;

implementation
  uses tg_glob;

  function ErrorMsg(ErrorCode:byte):string;
    function Int2Str(i:LongInt):string;
    var
      s : string[11];
    begin
      str(i,s);
      int2str:=s;
    end;{int2str}
  begin
    case errorcode of
      {/ internal errors /}
      er_AllOk            : ErrorMsg:='Ok';
      er_MemoryError      : ErrorMsg:='Not enought of memory :-(';
      er_TicError         : ErrorMsg:='Error in TIC file!';
      er_OtherError       : ErrorMsg:='';
      {/ dos errors /}
      er_FileNotFound     : ErrorMsg:='File not found';
      er_PathNotFound     : ErrorMsg:='Invalid path';
      er_TooManyOpenFiles : ErrorMsg:='Too many open files';
      er_FileAccessDenied : ErrorMsg:='Access denied';
      er_InvDriveNum      : ErrorMsg:='Invalid drive';
      er_CantRenAcrDrv    : ErrorMsg:='Cant rename across drives';
      {/ i/o errors /}
      er_DiskReadError    : ErrorMsg:='Disk read error';
      er_DiskWriteError   : ErrorMsg:='Disk full or write error';
      er_FileNotOpen      : ErrorMsg:='File not open';
      {/ critical errors /}
      er_DiskWriteProt    : ErrorMsg:='File locked or disk write protect';
      er_UnknownUnit      : ErrorMsg:='Unknown unit';
      er_DriveNotReady    : ErrorMsg:='Drive not ready';
      er_UnknownCommand   : ErrorMsg:='Unknown command';
      er_CrcErrorInData   : ErrorMsg:='CRC error in data';
      er_BadDrvReq        : ErrorMsg:='Bad drive request structure length';
      er_DiskSeekError    : ErrorMsg:='Disk seek error';
      er_UnknownMediaType : ErrorMsg:='Unknown media type';
      er_SectorNotFound   : ErrorMsg:='Sector not found';
      er_DeviceWriteFault : ErrorMsg:='Device write fault';
      er_DeviceReadFault  : ErrorMsg:='Device read fault';
      er_HardwareFailure  : ErrorMsg:='Hardware failure';
    else
      errormsg:='Unknown error #'+Int2Str(ErrorCode);
    end;
  end;{ErrorMsg}
begin
end.